/*
 Copyright (c) 2006-2016 Trellis Management Co. Ltd.

 This software module is an implementation of one or more tools as proposed
 for the JPEG XT standard.
 
 The copyright in this software is being made available under the
 license included with the sources LICENSE.TXT. This software may be subject to other third
 party and contributor rights, including patent rights, and no such
 rights are granted under this license. 
*/

#ifndef _encoder_h
#define _encoder_h
#include "image.h"
#include "jpeg_io.h"

#define HDR_MIN_VAL 1e-6

int xdp_encode(FILE_IMAGE *hdr_image, int use_prencode, const char *out_filename, float autobalance, int quality_hdr, int subsamp_hdr, int quality_ldr, int subsamp_ldr, float gamma_compatibile, int srgb, float gamma_hdr, int auto_gamma_hdr, FILE_IMAGE* png_test, int input_xyz, float base_matrix[], float resi_matrix[], int resi_identity);
int xdp_decode(const char *xdpeth_image, const char *hdr_file);
int xdp_HDREncode(FILE_IMAGE *hdr_image, int pre_encoded, MEMORY_FILE_IMAGE **out_24bit_image_prencoded, FILE_IMAGE **out_24bit_image, FILE_IMAGE **out_hdr_image, float gamma_hdr, int auto_hdr_gamma, float *generated_auto_gamma, int auto_balance, float *out_exp_value, float scale_factor, float lg, FILE_IMAGE *png_test, float *min_r, float *min_g, float *min_b, float *max_r, float *max_g, float *max_b, int input_xyz, int srgb, float base_matrix[], float resi_matrix[], int resi_identity, JPG_INFO *jpg_info);
#endif
