/*
 Copyright (c) 2006-2016 Trellis Management Co. Ltd.

 This software module is an implementation of one or more tools as proposed
 for the JPEG XT standard.
 
 The copyright in this software is being made available under the
 license included with the sources LICENSE.TXT. This software may be subject to other third
 party and contributor rights, including patent rights, and no such
 rights are granted under this license. 
*/

#ifndef _xdp_jpeg_hdr_h
#define _xdp_jpeg_hdr_h

#if defined(_MSC_VER)
#define _ALIGNED
#pragma pack(push)
#pragma pack(1)
#else
#if defined(__GNUC__)
#define _ALIGNED __attribute__ ((packed))
#endif
#endif

#define XDEPTH_PROFILE_TYPE 3

typedef struct _jpgxt_superbox_
{
    unsigned short jpg_tag;
    unsigned short Le;
    unsigned short CI;
    unsigned short En;
    unsigned int Z;
    unsigned int LBox;
    unsigned int TBox;
} _ALIGNED JPXT_SUPERBOX;

typedef struct _base_non_linear_trafo
{
    unsigned int LBox;
    unsigned int TBox;
    unsigned char td0td1;
    unsigned char td2td3;
} _ALIGNED JPXT_BASE_NON_LINEAR_TRAFO;

typedef struct _out_conv_box
{
    unsigned int LBox;
    unsigned int TBox;
    unsigned char RbLfOcCeOl;
    unsigned char to0to1;
    unsigned char to2to3;
} _ALIGNED JPXT_OUT_CONV_BOX;

typedef struct _color_trafo
{
    unsigned int LBox;
    unsigned int TBox;
    unsigned char CXtCRe;
} _ALIGNED JPXT_COLOR_TRAFO;

typedef struct _resi_trafo
{
    unsigned int LBox;
    unsigned int TBox;
    unsigned char DXtDRc;
} _ALIGNED JPXT_RESI_TRAFO;

typedef struct _sbox_curv
{
    unsigned int LBox;
    unsigned int TBox;
    unsigned char Mt;
    unsigned char et;
    float p1;
    float p2;
    float p3;
    float p4;
} _ALIGNED JPXT_CURV;

typedef struct _sbox_fp_lin_trafo
{
    unsigned int LBox;
    unsigned int TBox;
    unsigned char Mt;
    float a11;
    float a12;
    float a13;
    float a21;
    float a22;
    float a23;
    float a31;
    float a32;
    float a33;
} _ALIGNED JPXT_FP_LIN_TRAFO;

enum
{
    CS_RGB=0,
    CS_XYZ
};

typedef struct _payload_ftyp_
{
    unsigned int BR;
    unsigned int MinV;
    unsigned int CL;
} _ALIGNED JPXT_FTYPE;

typedef struct xdp_bin_block
{
    unsigned int block_version;
    float hdr_gamma;
    float ldr_gamma;
    float p1;
    float p2;
    float p3;
    float expval;
    float max_r;
    float max_g;
    float max_b;
    float min_r;
    float min_g;
    float min_b;
    int srgb;
    int log_decoding;
    unsigned char tmo;
    unsigned short cheksum;
    unsigned char colorspace;
    float log_params_ldr[4];
    float log_params_hdr[4];
    float base_matrix[9];
    float resi_matrix[9];
    int resi_identity;
    int rd_e_param;
    float Rb;
    float epsilon_div;
} _ALIGNED XDEPTH_INFO;

#if defined(_MSC_VER)
#pragma pack(pop)
#endif
#endif
